aboutsummaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
authorMauro Sardara <msardara@cisco.com>2022-08-16 09:43:05 +0200
committerMauro Sardara <msardara@cisco.com>2022-08-17 17:58:36 +0200
commit309fafddc51697deb9c6f8bf723c10539224cb4d (patch)
tree5f50208043312c0ec0a7680d8ff2fc70f497085c /scripts
parent7f18fb8e83a9cd4d32b6bf0eb39503cf2f551b4a (diff)
ci(functional-tests): add functional tests scripts
- Add scripts/functional-tests.sh script - Add `download_artifacts` functions, allowing to retrieve artifacts of a gerrit patch - Robot: redirect output of topology build to files, thus preventing robot from hanging - Share folders between host and containers with the :z flag - Use sudo to install executable in docker-compose scripts, as the user of the docker is not root anymore - Makefile: decouple installation and build Ref: HICN-732 Change-Id: Ib945cf7bd0ee331e33270cf1005dfebd085862eb Signed-off-by: Mauro Sardara <msardara@cisco.com>
Diffstat (limited to 'scripts')
-rw-r--r--scripts/build-packages.sh16
-rw-r--r--scripts/functional-tests.sh35
-rw-r--r--scripts/functions.sh46
3 files changed, 79 insertions, 18 deletions
diff --git a/scripts/build-packages.sh b/scripts/build-packages.sh
index c1e548bf0..0ac9dce8b 100644
--- a/scripts/build-packages.sh
+++ b/scripts/build-packages.sh
@@ -40,21 +40,6 @@ function build_package() {
echo "*******************************************************************"
}
-function functional_test() {
- echo "*******************************************************************"
- echo "********************* STARTING FUNCTIONAL TESTS *******************"
- echo "*******************************************************************"
-
- # Run functional tests
- pushd ${SCRIPT_PATH}/..
- BUILD_SOFTWARE=0 DOCKERFILE="tests/Dockerfile.ci" bash ./tests/run-functional.sh
- popd
-
- echo "*******************************************************************"
- echo "********** FUNCTIONAL TESTS COMPLETED SUCCESSFULLY ***************"
- echo "*******************************************************************"
-}
-
build_sphinx() {
setup
@@ -84,7 +69,6 @@ case "${1}" in
;;
packages)
build_package
- functional_test
;;
vpp_master)
;;
diff --git a/scripts/functional-tests.sh b/scripts/functional-tests.sh
new file mode 100644
index 000000000..05cc4193b
--- /dev/null
+++ b/scripts/functional-tests.sh
@@ -0,0 +1,35 @@
+# Copyright (c) 2017-2022 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+#!/bin/bash
+
+set -euxo pipefail
+
+SCRIPT_PATH=$( cd "$(dirname "${BASH_SOURCE}")" ; pwd -P )
+source "${SCRIPT_PATH}/functions.sh"
+
+echo "---------------------------------------------------------"
+echo "----- INSTALLING FUNCTIONAL TEST DEPENDENCIES ---------"
+echo "---------------------------------------------------------"
+
+# This docker compose version is well supported also in CentOS.
+# Versions >= 2.0.0 do not seem to work.
+DOCKER_COMPOSE_VERSION=1.29.2
+
+sudo curl -L "https://github.com/docker/compose/releases/download/${DOCKER_COMPOSE_VERSION}/docker-compose-$(uname -s)-$(uname -m)" -o /usr/local/bin/docker-compose
+sudo chmod +x /usr/local/bin/docker-compose
+sudo pip3 install robotframework
+
+functional_test
+
+exit 0
diff --git a/scripts/functions.sh b/scripts/functions.sh
index 147f6669c..06673f888 100644
--- a/scripts/functions.sh
+++ b/scripts/functions.sh
@@ -56,8 +56,6 @@ function call_once() {
# Install dependencies
function install_deps() {
- curl -fsSL https://get.docker.com -o get-docker.sh
- sudo sh get-docker.sh
make -C ${SCRIPT_PATH}/.. deps
}
@@ -75,3 +73,47 @@ function setup_extras() {
call_once install_deps
call_once install_collectd_headers
}
+
+# Download artifacts of this patchset from jenkins
+function download_artifacts() {
+ if [[ -n ${GERRIT_HOST:-} ]] &&
+ [[ -n ${GERRIT_CHANGE_NUMBER:-} ]] &&
+ [[ -n ${GERRIT_PATCHSET_NUMBER:-} ]]; then
+
+ # Retrieve the Jenkins URL of the build relative to this PATCHSET
+ JENKINS_URL=$(
+ curl -s "https://${GERRIT_HOST}/r/changes/${GERRIT_CHANGE_NUMBER}/detail" |
+ tail -n +2 | jq '.messages[].message?' |
+ grep -E "Patch Set ${GERRIT_PATCHSET_NUMBER}:.*hicn-verify-build.*build_success-hicn-ubuntu2004-$(uname -m)" |
+ grep -Eo "https?://jenkins.fd.io/job/hicn-verify-build-hicn-ubuntu2004-$(uname -m)[^ ]+"
+ )
+ ARTIFACTS_URL="${JENKINS_URL}/artifact/packages/*zip*/packages.zip"
+
+ # Download artifacts
+ curl -o "${SCRIPT_PATH}/../packages.zip" -L "${ARTIFACTS_URL}"
+
+ # Unzip them
+ unzip "${SCRIPT_PATH}/../packages.zip" -d "${SCRIPT_PATH}/.."
+ else
+ echo "GERRIT_* environment is not set. Impossible to download artifacts." >&2
+ exit 1
+ fi
+}
+
+# Run functional tests
+function functional_test() {
+ echo "*******************************************************************"
+ echo "********************* STARTING FUNCTIONAL TESTS *******************"
+ echo "*******************************************************************"
+
+ download_artifacts
+
+ # Run functional tests
+ pushd ${SCRIPT_PATH}/../tests
+ BUILD_SOFTWARE=0 DOCKERFILE="tests/Dockerfile.ci" bash ./run-functional.sh
+ popd
+
+ echo "*******************************************************************"
+ echo "********** FUNCTIONAL TESTS COMPLETED SUCCESSFULLY ***************"
+ echo "*******************************************************************"
+}